# Class TextArea

java.lang.Object
java.awt.Component
java.awt.TextComponent
java.awt.TextArea

All Implemented Interfaces:
  `ImageObserver, MenuContainer, Serializable, Accessible`

public non-sealed class TextArea extends TextComponent
A `TextArea` object is a multi-line region that displays text. It can be set to allow editing or to be read-only.

The following image shows the appearance of a text area:

This text area could be created by the following line of code:

>     new TextArea("Hello", 5, 40);

Since:
  1.0
See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`TextArea.AccessibleAWTTextArea`
This class implements accessibility support for the `TextArea` class.

### Nested classes/interfaces declared in class TextComponent

`TextComponent.AccessibleAWTTextComponent`
Modifier and Type
Class
Description
`protected class`
`TextComponent.AccessibleAWTTextComponent`
This class implements accessibility support for the `TextComponent` class.

### Nested classes/interfaces declared in class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
Modifier and Type
Class
Description
`protected class`
`Component.AccessibleAWTComponent`
Inner class of Component used to provide default support for accessibility.
`static enum`
`Component.BaselineResizeBehavior`
Enumeration of the common ways the baseline of a component can change as the size changes.
`protected class`
`Component.BltBufferStrategy`
Inner class for blitting offscreen surfaces to a component.
`protected class`
`Component.FlipBufferStrategy`
Inner class for flipping buffers on a component.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`SCROLLBARS_BOTH`
Create and display both vertical and horizontal scrollbars.
`static final int`
`SCROLLBARS_HORIZONTAL_ONLY`
Create and display horizontal scrollbar only.
`static final int`
`SCROLLBARS_NONE`
Do not create or display any scrollbars for the text area.
`static final int`
`SCROLLBARS_VERTICAL_ONLY`
Create and display vertical scrollbar only.

### Fields declared in class TextComponent

`textListener`
Modifier and Type
Field
Description
`protected TextListener`
`textListener`
A list of listeners that will receive events from this object.

### Fields declared in class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
Modifier and Type
Field
Description
`protected AccessibleContext`
`accessibleContext`
The `AccessibleContext` associated with this `Component`.
`static final float`
`BOTTOM_ALIGNMENT`
Ease-of-use constant for `getAlignmentY`.
`static final float`
`CENTER_ALIGNMENT`
Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
`static final float`
`LEFT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`RIGHT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`TOP_ALIGNMENT`
Ease-of-use constant for `getAlignmentY()`.

### Fields declared in interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
Modifier and Type
Field
Description
`static final int`
`ABORT`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
`static final int`
`ALLBITS`
This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
`static final int`
`ERROR`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
`static final int`
`FRAMEBITS`
This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
`static final int`
`HEIGHT`
This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
`static final int`
`PROPERTIES`
This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
`static final int`
`SOMEBITS`
This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
`static final int`
`WIDTH`
This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

## Constructor Summary

Constructors
Constructor
Description
`TextArea()`
Constructs a new text area with the empty string as text.
`TextArea(int rows, int columns)`
Constructs a new text area with the specified number of rows and columns and the empty string as text.
`TextArea(String text)`
Constructs a new text area with the specified text.
`TextArea(String text, int rows, int columns)`
Constructs a new text area with the specified text, and with the specified number of rows and columns.
`TextArea(String text, int rows, int columns, int scrollbars)`
Constructs a new text area with the specified text, and with the rows, columns, and scroll bar visibility as specified.

## Method Summary

Modifier and Type
Method
Description
`void`
`addNotify()`
Creates the `TextArea`'s peer.
`void`
`append(String str)`
Appends the given text to the text area's current text.
`void`
`appendText(String str)`
Deprecated.
As of JDK version 1.1, replaced by `append(String)`.
`AccessibleContext`
`getAccessibleContext()`
Returns the `AccessibleContext` associated with this `TextArea`.
`int`
`getColumns()`
Returns the number of columns in this text area.
`Dimension`
`getMinimumSize()`
Determines the minimum size of this text area.
`Dimension`
`getMinimumSize(int rows, int columns)`
Determines the minimum size of a text area with the specified number of rows and columns.
`Dimension`
`getPreferredSize()`
Determines the preferred size of this text area.
`Dimension`
`getPreferredSize(int rows, int columns)`
Determines the preferred size of a text area with the specified number of rows and columns.
`int`
`getRows()`
Returns the number of rows in the text area.
`int`
`getScrollbarVisibility()`
Returns an enumerated value that indicates which scroll bars the text area uses.
`void`
`insert(String str, int pos)`
Inserts the specified text at the specified position in this text area.
`void`
`insertText(String str, int pos)`
Deprecated.
As of JDK version 1.1, replaced by `insert(String, int)`.
`Dimension`
`minimumSize()`
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize()`.
`Dimension`
`minimumSize(int rows, int columns)`
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize(int, int)`.
`protected String`
`paramString()`
Returns a string representing the state of this `TextArea`.
`Dimension`
`preferredSize()`
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize()`.
`Dimension`
`preferredSize(int rows, int columns)`
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize(int, int)`.
`void`
`replaceRange(String str, int start, int end)`
Replaces text between the indicated start and end positions with the specified replacement text.
`void`
`replaceText(String str, int start, int end)`
Deprecated.
As of JDK version 1.1, replaced by `replaceRange(String, int, int)`.
`void`
`setColumns(int columns)`
Sets the number of columns for this text area.
`void`
`setRows(int rows)`
Sets the number of rows for this text area.

### Methods declared in class TextComponent

`addTextListener, enableInputMethods, getBackground, getCaretPosition, getListeners, getSelectedText, getSelectionEnd, getSelectionStart, getText, getTextListeners, isEditable, processEvent, processTextEvent, removeNotify, removeTextListener, select, selectAll, setBackground, setCaretPosition, setEditable, setSelectionEnd, setSelectionStart, setText`
Modifier and Type
Method
Description
`void`
`addTextListener(TextListener l)`
Adds the specified text event listener to receive text events from this text component.
`void`
`enableInputMethods(boolean enable)`
Enables or disables input method support for this text component.
`Color`
`getBackground()`
Gets the background color of this text component.
`int`
`getCaretPosition()`
Returns the position of the text insertion caret.
`<T extends EventListener>
T[]`
`getListeners(Class<T> listenerType)`
Returns an array of all the objects currently registered as `FooListener`s upon this `TextComponent`.
`String`
`getSelectedText()`
Returns the selected text from the text that is presented by this text component.
`int`
`getSelectionEnd()`
Gets the end position of the selected text in this text component.
`int`
`getSelectionStart()`
Gets the start position of the selected text in this text component.
`String`
`getText()`
Returns the text that is presented by this text component.
`TextListener[]`
`getTextListeners()`
Returns an array of all the text listeners registered on this text component.
`boolean`
`isEditable()`
Indicates whether or not this text component is editable.
`protected void`
`processEvent(AWTEvent e)`
Processes events on this text component.
`protected void`
`processTextEvent(TextEvent e)`
Processes text events occurring on this text component by dispatching them to any registered `TextListener` objects.
`void`
`removeNotify()`
Removes the `TextComponent`'s peer.
`void`
`removeTextListener(TextListener l)`
Removes the specified text event listener so that it no longer receives text events from this text component If `l` is `null`, no exception is thrown and no action is performed.
`void`
`select(int selectionStart, int selectionEnd)`
Selects the text between the specified start and end positions.
`void`
`selectAll()`
Selects all the text in this text component.
`void`
`setBackground(Color c)`
Sets the background color of this text component.
`void`
`setCaretPosition(int position)`
Sets the position of the text insertion caret.
`void`
`setEditable(boolean b)`
Sets the flag that determines whether or not this text component is editable.
`void`
`setSelectionEnd(int selectionEnd)`
Sets the selection end for this text component to the specified position.
`void`
`setSelectionStart(int selectionStart)`
Sets the selection start for this text component to the specified position.
`void`
`setText(String t)`
Sets the text that is presented by this text component to be the specified text.

### Methods declared in class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`
Modifier and Type
Method
Description
`boolean`
`action(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
`void`
`add(PopupMenu popup)`
Adds the specified popup menu to the component.
`void`
`addComponentListener(ComponentListener l)`
Adds the specified component listener to receive component events from this component.
`void`
`addFocusListener(FocusListener l)`
Adds the specified focus listener to receive focus events from this component when this component gains input focus.
`void`
`addHierarchyBoundsListener(HierarchyBoundsListener l)`
Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
`void`
`addHierarchyListener(HierarchyListener l)`
Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
`void`
`addInputMethodListener(InputMethodListener l)`
Adds the specified input method listener to receive input method events from this component.
`void`
`addKeyListener(KeyListener l)`
Adds the specified key listener to receive key events from this component.
`void`
`addMouseListener(MouseListener l)`
Adds the specified mouse listener to receive mouse events from this component.
`void`
`addMouseMotionListener(MouseMotionListener l)`
Adds the specified mouse motion listener to receive mouse motion events from this component.
`void`
`addMouseWheelListener(MouseWheelListener l)`
Adds the specified mouse wheel listener to receive mouse wheel events from this component.
`void`
`addPropertyChangeListener(PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list.
`void`
`addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list for a specific property.
`void`
`applyComponentOrientation(ComponentOrientation orientation)`
Sets the `ComponentOrientation` property of this component and all components contained within it.
`boolean`
`areFocusTraversalKeysSet(int id)`
Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Component.
`Rectangle`
`bounds()`
Deprecated.
As of JDK version 1.1, replaced by `getBounds()`.
`int`
`checkImage(Image image, int width, int height, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`int`
`checkImage(Image image, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`protected AWTEvent`
`coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
Potentially coalesce an event being posted with an existing event.
`boolean`
`contains(int x, int y)`
Checks whether this component "contains" the specified point, where `x` and `y` are defined to be relative to the coordinate system of this component.
`boolean`
`contains(Point p)`
Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
`Image`
`createImage(int width, int height)`
Creates an off-screen drawable image to be used for double buffering.
`Image`
`createImage(ImageProducer producer)`
Creates an image from the specified image producer.
`VolatileImage`
`createVolatileImage(int width, int height)`
Creates a volatile off-screen drawable image to be used for double buffering.
`VolatileImage`
`createVolatileImage(int width, int height, ImageCapabilities caps)`
Creates a volatile off-screen drawable image, with the given capabilities.
`void`
`deliverEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`.
`void`
`disable()`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`disableEvents(long eventsToDisable)`
Disables the events defined by the specified event mask parameter from being delivered to this component.
`final void`
`dispatchEvent(AWTEvent e)`
Dispatches an event to this component or one of its sub components.
`void`
`doLayout()`
Prompts the layout manager to lay out this component.
`void`
`enable()`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`void`
`enable(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`enableEvents(long eventsToEnable)`
Enables the events defined by the specified event mask parameter to be delivered to this component.
`protected void`
`firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
Support for reporting bound property changes for boolean properties.
`void`
`firePropertyChange(String propertyName, byte oldValue, byte newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, char oldValue, char newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, double oldValue, double newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, float oldValue, float newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, int oldValue, int newValue)`
Support for reporting bound property changes for integer properties.
`void`
`firePropertyChange(String propertyName, long oldValue, long newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, short oldValue, short newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, Object oldValue, Object newValue)`
Support for reporting bound property changes for Object properties.
`float`
`getAlignmentX()`
Returns the alignment along the x axis.
`float`
`getAlignmentY()`
Returns the alignment along the y axis.
`int`
`getBaseline(int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior()`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Rectangle`
`getBounds()`
Gets the bounds of this component in the form of a `Rectangle` object.
`Rectangle`
`getBounds(Rectangle rv)`
Stores the bounds of this component into "return value" rv and return rv.
`ColorModel`
`getColorModel()`
Gets the instance of `ColorModel` used to display the component on the output device.
`Component`
`getComponentAt(int x, int y)`
Determines if this component or one of its immediate subcomponents contains the (x, y) location, and if so, returns the containing component.
`Component`
`getComponentAt(Point p)`
Returns the component or subcomponent that contains the specified point.
`ComponentListener[]`
`getComponentListeners()`
Returns an array of all the component listeners registered on this component.
`ComponentOrientation`
`getComponentOrientation()`
Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
`Cursor`
`getCursor()`
Gets the cursor set in the component.
`DropTarget`
`getDropTarget()`
Gets the `DropTarget` associated with this `Component`.
`Container`
`getFocusCycleRootAncestor()`
Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
`FocusListener[]`
`getFocusListeners()`
Returns an array of all the focus listeners registered on this component.
`Set<AWTKeyStroke>`
`getFocusTraversalKeys(int id)`
Returns the Set of focus traversal keys for a given traversal operation for this Component.
`boolean`
`getFocusTraversalKeysEnabled()`
Returns whether focus traversal keys are enabled for this Component.
`Font`
`getFont()`
Gets the font of this component.
`FontMetrics`
`getFontMetrics(Font font)`
Gets the font metrics for the specified font.
`Color`
`getForeground()`
Gets the foreground color of this component.
`Graphics`
`getGraphics()`
Creates a graphics context for this component.
`GraphicsConfiguration`
`getGraphicsConfiguration()`
Gets the `GraphicsConfiguration` associated with this `Component`.
`int`
`getHeight()`
Returns the current height of this component.
`HierarchyBoundsListener[]`
`getHierarchyBoundsListeners()`
Returns an array of all the hierarchy bounds listeners registered on this component.
`HierarchyListener[]`
`getHierarchyListeners()`
Returns an array of all the hierarchy listeners registered on this component.
`boolean`
`getIgnoreRepaint()`
Returns whether or not paint messages received from the operating system should be ignored.
`InputContext`
`getInputContext()`
Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
`InputMethodListener[]`
`getInputMethodListeners()`
Returns an array of all the input method listeners registered on this component.
`InputMethodRequests`
`getInputMethodRequests()`
Gets the input method request handler which supports requests from input methods for this component.
`KeyListener[]`
`getKeyListeners()`
Returns an array of all the key listeners registered on this component.
`Locale`
`getLocale()`
Gets the locale of this component.
`Point`
`getLocation()`
Gets the location of this component in the form of a point specifying the component's top-left corner.
`Point`
`getLocation(Point rv)`
Stores the x,y origin of this component into "return value" rv and return rv.
`Point`
`getLocationOnScreen()`
Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
`Dimension`
`getMaximumSize()`
Gets the maximum size of this component.
`MouseListener[]`
`getMouseListeners()`
Returns an array of all the mouse listeners registered on this component.
`MouseMotionListener[]`
`getMouseMotionListeners()`
Returns an array of all the mouse motion listeners registered on this component.
`Point`
`getMousePosition()`
Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
`MouseWheelListener[]`
`getMouseWheelListeners()`
Returns an array of all the mouse wheel listeners registered on this component.
`String`
`getName()`
Gets the name of the component.
`Container`
`getParent()`
Gets the parent of this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners()`
Returns an array of all the property change listeners registered on this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners(String propertyName)`
Returns an array of all the listeners which have been associated with the named property.
`Dimension`
`getSize()`
Returns the size of this component in the form of a `Dimension` object.
`Dimension`
`getSize(Dimension rv)`
Stores the width/height of this component into "return value" rv and return rv.
`Toolkit`
`getToolkit()`
Gets the toolkit of this component.
`final Object`
`getTreeLock()`
Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
`int`
`getWidth()`
Returns the current width of this component.
`int`
`getX()`
Returns the current x coordinate of the components origin.
`int`
`getY()`
Returns the current y coordinate of the components origin.
`boolean`
`gotFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`handleEvent(Event evt)`
Deprecated.
As of JDK version 1.1 replaced by processEvent(AWTEvent).
`boolean`
`hasFocus()`
Returns `true` if this `Component` is the focus owner.
`void`
`hide()`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`boolean`
`imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
Repaints the component when the image has changed.
`boolean`
`inside(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by contains(int, int).
`void`
`invalidate()`
Invalidates this component and its ancestors.
`boolean`
`isBackgroundSet()`
Returns whether the background color has been explicitly set for this Component.
`boolean`
`isCursorSet()`
Returns whether the cursor has been explicitly set for this Component.
`boolean`
`isDisplayable()`
Determines whether this component is displayable.
`boolean`
`isDoubleBuffered()`
Returns true if this component is painted to an offscreen image ("buffer") that's copied to the screen later.
`boolean`
`isEnabled()`
Determines whether this component is enabled.
`boolean`
`isFocusable()`
Returns whether this Component can be focused.
`boolean`
`isFocusCycleRoot(Container container)`
Returns whether the specified Container is the focus cycle root of this Component's focus traversal cycle.
`boolean`
`isFocusOwner()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`isFocusTraversable()`
Deprecated.
As of 1.4, replaced by `isFocusable()`.
`boolean`
`isFontSet()`
Returns whether the font has been explicitly set for this Component.
`boolean`
`isForegroundSet()`
Returns whether the foreground color has been explicitly set for this Component.
`boolean`
`isLightweight()`
A lightweight component doesn't have a native toolkit peer.
`boolean`
`isMaximumSizeSet()`
Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
`boolean`
`isMinimumSizeSet()`
Returns whether or not `setMinimumSize` has been invoked with a non-null value.
`boolean`
`isOpaque()`
Returns true if this component is completely opaque, returns false by default.
`boolean`
`isPreferredSizeSet()`
Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
`boolean`
`isShowing()`
Determines whether this component is showing on screen.
`boolean`
`isValid()`
Determines whether this component is valid.
`boolean`
`isVisible()`
Determines whether this component should be visible when its parent is visible.
`boolean`
`keyDown(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`boolean`
`keyUp(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`void`
`layout()`
Deprecated.
As of JDK version 1.1, replaced by `doLayout()`.
`void`
`list()`
Prints a listing of this component to the standard system output stream `System.out`.
`void`
`list(PrintStream out)`
Prints a listing of this component to the specified output stream.
`void`
`list(PrintStream out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print stream.
`void`
`list(PrintWriter out)`
Prints a listing to the specified print writer.
`void`
`list(PrintWriter out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print writer.
`Component`
`locate(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by getComponentAt(int, int).
`Point`
`location()`
Deprecated.
As of JDK version 1.1, replaced by `getLocation()`.
`boolean`
`lostFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`mouseDown(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseDrag(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseEnter(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseExit(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseMove(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseUp(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`void`
`move(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `setLocation(int, int)`.
`void`
`nextFocus()`
Deprecated.
As of JDK version 1.1, replaced by transferFocus().
`void`
`paint(Graphics g)`
Paints this component.
`void`
`paintAll(Graphics g)`
Paints this component and all of its subcomponents.
`boolean`
`postEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
`boolean`
`prepareImage(Image image, int width, int height, ImageObserver observer)`
Prepares an image for rendering on this component at the specified width and height.
`boolean`
`prepareImage(Image image, ImageObserver observer)`
Prepares an image for rendering on this component.
`void`
`print(Graphics g)`
Prints this component.
`void`
`printAll(Graphics g)`
Prints this component and all of its subcomponents.
`protected void`
`processComponentEvent(ComponentEvent e)`
Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
`protected void`
`processFocusEvent(FocusEvent e)`
Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
`protected void`
`processHierarchyBoundsEvent(HierarchyEvent e)`
Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
`protected void`
`processHierarchyEvent(HierarchyEvent e)`
Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
`protected void`
`processInputMethodEvent(InputMethodEvent e)`
Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
`protected void`
`processKeyEvent(KeyEvent e)`
Processes key events occurring on this component by dispatching them to any registered `KeyListener` objects.
`protected void`
`processMouseEvent(MouseEvent e)`
Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects.
`protected void`
`processMouseMotionEvent(MouseEvent e)`
Processes mouse motion events occurring on this component by dispatching them to any registered `MouseMotionListener` objects.
`protected void`
`processMouseWheelEvent(MouseWheelEvent e)`
Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
`void`
`remove(MenuComponent popup)`
Removes the specified popup menu from the component.
`void`
`removeComponentListener(ComponentListener l)`
Removes the specified component listener so that it no longer receives component events from this component.
`void`
`removeFocusListener(FocusListener l)`
Removes the specified focus listener so that it no longer receives focus events from this component.
`void`
`removeHierarchyBoundsListener(HierarchyBoundsListener l)`
Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
`void`
`removeHierarchyListener(HierarchyListener l)`
Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
`void`
`removeInputMethodListener(InputMethodListener l)`
Removes the specified input method listener so that it no longer receives input method events from this component.
`void`
`removeKeyListener(KeyListener l)`
Removes the specified key listener so that it no longer receives key events from this component.
`void`
`removeMouseListener(MouseListener l)`
Removes the specified mouse listener so that it no longer receives mouse events from this component.
`void`
`removeMouseMotionListener(MouseMotionListener l)`
Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
`void`
`removeMouseWheelListener(MouseWheelListener l)`
Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
`void`
`removePropertyChangeListener(PropertyChangeListener listener)`
Removes a PropertyChangeListener from the listener list.
`void`
`removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Removes a `PropertyChangeListener` from the listener list for a specific property.
`void`
`repaint()`
Repaints this component.
`void`
`repaint(int x, int y, int width, int height)`
Repaints the specified rectangle of this component.
`void`
`repaint(long tm)`
Repaints the component.
`void`
`repaint(long tm, int x, int y, int width, int height)`
Repaints the specified rectangle of this component within `tm` milliseconds.
`void`
`requestFocus()`
Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`protected boolean`
`requestFocus(boolean temporary)`
Requests that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`protected boolean`
`requestFocus(boolean temporary, FocusEvent.Cause cause)`
Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`void`
`requestFocus(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`boolean`
`requestFocusInWindow()`
Requests that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`protected boolean`
`requestFocusInWindow(boolean temporary)`
Requests that this `Component` get the input focus, if this `Component`'s top-level ancestor is already the focused `Window`.
`boolean`
`requestFocusInWindow(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`void`
`reshape(int x, int y, int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.
`void`
`resize(int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(int, int)`.
`void`
`resize(Dimension d)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(Dimension)`.
`void`
`revalidate()`
Revalidates the component hierarchy up to the nearest validate root.
`void`
`setBounds(int x, int y, int width, int height)`
Moves and resizes this component.
`void`
`setBounds(Rectangle r)`
Moves and resizes this component to conform to the new bounding rectangle `r`.
`void`
`setComponentOrientation(ComponentOrientation o)`
Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
`void`
`setCursor(Cursor cursor)`
Sets the cursor image to the specified cursor.
`void`
`setDropTarget(DropTarget dt)`
Associate a `DropTarget` with this component.
`void`
`setEnabled(boolean b)`
Enables or disables this component, depending on the value of the parameter `b`.
`void`
`setFocusable(boolean focusable)`
Sets the focusable state of this Component to the specified value.
`void`
`setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
Sets the focus traversal keys for a given traversal operation for this Component.
`void`
`setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
Sets whether focus traversal keys are enabled for this Component.
`void`
`setFont(Font f)`
Sets the font of this component.
`void`
`setForeground(Color c)`
Sets the foreground color of this component.
`void`
`setIgnoreRepaint(boolean ignoreRepaint)`
Sets whether or not paint messages received from the operating system should be ignored.
`void`
`setLocale(Locale l)`
Sets the locale of this component.
`void`
`setLocation(int x, int y)`
Moves this component to a new location.
`void`
`setLocation(Point p)`
Moves this component to a new location.
`void`
`setMaximumSize(Dimension maximumSize)`
Sets the maximum size of this component to a constant value.
`void`
`setMinimumSize(Dimension minimumSize)`
Sets the minimum size of this component to a constant value.
`void`
`setMixingCutoutShape(Shape shape)`
Sets a 'mixing-cutout' shape for this lightweight component.
`void`
`setName(String name)`
Sets the name of the component to the specified string.
`void`
`setPreferredSize(Dimension preferredSize)`
Sets the preferred size of this component to a constant value.
`void`
`setSize(int width, int height)`
Resizes this component so that it has width `width` and height `height`.
`void`
`setSize(Dimension d)`
Resizes this component so that it has width `d.width` and height `d.height`.
`void`
`setVisible(boolean b)`
Shows or hides this component depending on the value of parameter `b`.
`void`
`show()`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`void`
`show(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`Dimension`
`size()`
Deprecated.
As of JDK version 1.1, replaced by `getSize()`.
`String`
`toString()`
Returns a string representation of this component and its values.
`void`
`transferFocus()`
Transfers the focus to the next component, as though this Component were the focus owner.
`void`
`transferFocusBackward()`
Transfers the focus to the previous component, as though this Component were the focus owner.
`void`
`transferFocusUpCycle()`
Transfers the focus up one focus traversal cycle.
`void`
`update(Graphics g)`
Updates this component.
`void`
`validate()`
Validates this component.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### SCROLLBARS_BOTH

public static final int SCROLLBARS_BOTH
Create and display both vertical and horizontal scrollbars.

Since:
  1.1
See Also:
  - Constant Field Values

### SCROLLBARS_VERTICAL_ONLY

public static final int SCROLLBARS_VERTICAL_ONLY
Create and display vertical scrollbar only.

Since:
  1.1
See Also:
  - Constant Field Values

### SCROLLBARS_HORIZONTAL_ONLY

public static final int SCROLLBARS_HORIZONTAL_ONLY
Create and display horizontal scrollbar only.

Since:
  1.1
See Also:
  - Constant Field Values

### SCROLLBARS_NONE

public static final int SCROLLBARS_NONE
Do not create or display any scrollbars for the text area.

Since:
  1.1
See Also:
  - Constant Field Values

## Constructor Details

### TextArea

public TextArea() throws HeadlessException
Constructs a new text area with the empty string as text. This text area is created with scrollbar visibility equal to `SCROLLBARS_BOTH`, so both vertical and horizontal scrollbars will be visible for this text area.

Throws:
  `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns true
See Also:
  - `GraphicsEnvironment.isHeadless()`

### TextArea

public TextArea(String text) throws HeadlessException
Constructs a new text area with the specified text. This text area is created with scrollbar visibility equal to `SCROLLBARS_BOTH`, so both vertical and horizontal scrollbars will be visible for this text area.

Parameters:
  `text` - the text to be displayed; if `text` is `null`, the empty string `""` will be displayed
Throws:
  `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns true
See Also:
  - `GraphicsEnvironment.isHeadless()`

### TextArea

public TextArea(int rows, int columns) throws HeadlessException
Constructs a new text area with the specified number of rows and columns and the empty string as text. A column is an approximate average character width that is platform-dependent. The text area is created with scrollbar visibility equal to `SCROLLBARS_BOTH`, so both vertical and horizontal scrollbars will be visible for this text area.

Parameters:
  `rows` - the number of rows
  `columns` - the number of columns
Throws:
  `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns true
See Also:
  - `GraphicsEnvironment.isHeadless()`

### TextArea

public TextArea(String text, int rows, int columns) throws HeadlessException
Constructs a new text area with the specified text, and with the specified number of rows and columns. A column is an approximate average character width that is platform-dependent. The text area is created with scrollbar visibility equal to `SCROLLBARS_BOTH`, so both vertical and horizontal scrollbars will be visible for this text area.

Parameters:
  `text` - the text to be displayed; if `text` is `null`, the empty string `""` will be displayed
  `rows` - the number of rows
  `columns` - the number of columns
Throws:
  `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns true
See Also:
  - `GraphicsEnvironment.isHeadless()`

### TextArea

public TextArea(String text, int rows, int columns, int scrollbars) throws HeadlessException
Constructs a new text area with the specified text, and with the rows, columns, and scroll bar visibility as specified. All `TextArea` constructors defer to this one.

The `TextArea` class defines several constants that can be supplied as values for the `scrollbars` argument:

- `SCROLLBARS_BOTH`,
- `SCROLLBARS_VERTICAL_ONLY`,
- `SCROLLBARS_HORIZONTAL_ONLY`,
- `SCROLLBARS_NONE`.

Any other value for the `scrollbars` argument is invalid and will result in this text area being created with scrollbar visibility equal to the default value of `SCROLLBARS_BOTH`.

Parameters:
  `text` - the text to be displayed; if `text` is `null`, the empty string `""` will be displayed
  `rows` - the number of rows; if `rows` is less than `0`, `rows` is set to `0`
  `columns` - the number of columns; if `columns` is less than `0`, `columns` is set to `0`
  `scrollbars` - a constant that determines what scrollbars are created to view the text area
Throws:
  `HeadlessException` - if `GraphicsEnvironment.isHeadless` returns true
Since:
  1.1
See Also:
  - `GraphicsEnvironment.isHeadless()`

## Method Details

### addNotify

public void addNotify()
Creates the `TextArea`'s peer. The peer allows us to modify the appearance of the `TextArea` without changing any of its functionality.

Overrides:
  `addNotify` in class `TextComponent`
See Also:
  - `TextComponent.removeNotify()`

### insert

public void insert(String str, int pos)
Inserts the specified text at the specified position in this text area.

Note that passing `null` or inconsistent parameters is invalid and will result in unspecified behavior.

Parameters:
  `str` - the non-`null` text to insert
  `pos` - the position at which to insert
Since:
  1.1
See Also:
  - `TextComponent.setText(String)`
  - `replaceRange(String, int, int)`
  - `append(String)`

### insertText

@Deprecated public void insertText(String str, int pos)
Deprecated.
As of JDK version 1.1, replaced by `insert(String, int)`.
Inserts the specified text at the specified position in this text area.

Parameters:
  `str` - the non-`null` text to insert
  `pos` - the position at which to insert

### append

public void append(String str)
Appends the given text to the text area's current text.

Note that passing `null` or inconsistent parameters is invalid and will result in unspecified behavior.

Parameters:
  `str` - the non-`null` text to append
Since:
  1.1
See Also:
  - `insert(String, int)`

### appendText

@Deprecated public void appendText(String str)
Deprecated.
As of JDK version 1.1, replaced by `append(String)`.
Appends the given text to the text area's current text.

Parameters:
  `str` - the text to append

### replaceRange

public void replaceRange(String str, int start, int end)
Replaces text between the indicated start and end positions with the specified replacement text. The text at the end position will not be replaced. The text at the start position will be replaced (unless the start position is the same as the end position). The text position is zero-based. The inserted substring may be of a different length than the text it replaces.

Note that passing `null` or inconsistent parameters is invalid and will result in unspecified behavior.

Parameters:
  `str` - the non-`null` text to use as the replacement
  `start` - the start position
  `end` - the end position
Since:
  1.1
See Also:
  - `insert(String, int)`

### replaceText

@Deprecated public void replaceText(String str, int start, int end)
Deprecated.
As of JDK version 1.1, replaced by `replaceRange(String, int, int)`.
Replaces a range of characters between the indicated start and end positions with the specified replacement text (the text at the end position will not be replaced).

Parameters:
  `str` - the non-`null` text to use as the replacement
  `start` - the start position
  `end` - the end position

### getRows

public int getRows()
Returns the number of rows in the text area.

Returns:
  the number of rows in the text area
Since:
  1.0
See Also:
  - `setRows(int)`
  - `getColumns()`

### setRows

public void setRows(int rows)
Sets the number of rows for this text area.

Parameters:
  `rows` - the number of rows
Throws:
  `IllegalArgumentException` - if the value supplied for `rows` is less than `0`
Since:
  1.1
See Also:
  - `getRows()`
  - `setColumns(int)`

### getColumns

public int getColumns()
Returns the number of columns in this text area.

Returns:
  the number of columns in the text area
See Also:
  - `setColumns(int)`
  - `getRows()`

### setColumns

public void setColumns(int columns)
Sets the number of columns for this text area.

Parameters:
  `columns` - the number of columns
Throws:
  `IllegalArgumentException` - if the value supplied for `columns` is less than `0`
Since:
  1.1
See Also:
  - `getColumns()`
  - `setRows(int)`

### getScrollbarVisibility

public int getScrollbarVisibility()
Returns an enumerated value that indicates which scroll bars the text area uses.

The `TextArea` class defines four integer constants that are used to specify which scroll bars are available. `TextArea` has one constructor that gives the application discretion over scroll bars.

Returns:
  an integer that indicates which scroll bars are used
Since:
  1.1
See Also:
  - `SCROLLBARS_BOTH`
  - `SCROLLBARS_VERTICAL_ONLY`
  - `SCROLLBARS_HORIZONTAL_ONLY`
  - `SCROLLBARS_NONE`
  - `TextArea(java.lang.String, int, int, int)`

### getPreferredSize

public Dimension getPreferredSize(int rows, int columns)
Determines the preferred size of a text area with the specified number of rows and columns.

Parameters:
  `rows` - the number of rows
  `columns` - the number of columns
Returns:
  the preferred dimensions required to display the text area with the specified number of rows and columns
Since:
  1.1
See Also:
  - `Component.getPreferredSize()`

### preferredSize

@Deprecated public Dimension preferredSize(int rows, int columns)
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize(int, int)`.
Determines the preferred size of the text area with the specified number of rows and columns.

Parameters:
  `rows` - the number of rows
  `columns` - the number of columns
Returns:
  the preferred dimensions needed for the text area

### getPreferredSize

public Dimension getPreferredSize()
Determines the preferred size of this text area.

Overrides:
  `getPreferredSize` in class `Component`
Returns:
  the preferred dimensions needed for this text area
Since:
  1.1
See Also:
  - `Component.getPreferredSize()`

### preferredSize

@Deprecated public Dimension preferredSize()
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize()`.
Description copied from class: `Component`
Returns the component's preferred size.

Overrides:
  `preferredSize` in class `Component`
Returns:
  the component's preferred size

### getMinimumSize

public Dimension getMinimumSize(int rows, int columns)
Determines the minimum size of a text area with the specified number of rows and columns.

Parameters:
  `rows` - the number of rows
  `columns` - the number of columns
Returns:
  the minimum dimensions required to display the text area with the specified number of rows and columns
Since:
  1.1
See Also:
  - `Component.getMinimumSize()`

### minimumSize

@Deprecated public Dimension minimumSize(int rows, int columns)
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize(int, int)`.
Determines the minimum size of the text area with the specified number of rows and columns.

Parameters:
  `rows` - the number of rows
  `columns` - the number of columns
Returns:
  the minimum size for the text area

### getMinimumSize

public Dimension getMinimumSize()
Determines the minimum size of this text area.

Overrides:
  `getMinimumSize` in class `Component`
Returns:
  the preferred dimensions needed for this text area
Since:
  1.1
See Also:
  - `Component.getPreferredSize()`

### minimumSize

@Deprecated public Dimension minimumSize()
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize()`.
Description copied from class: `Component`
Returns the minimum size of this component.

Overrides:
  `minimumSize` in class `Component`
Returns:
  the minimum size of this component

### paramString

protected String paramString()
Returns a string representing the state of this `TextArea`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

Overrides:
  `paramString` in class `TextComponent`
Returns:
  the parameter string of this text area

### getAccessibleContext

public AccessibleContext getAccessibleContext()
Returns the `AccessibleContext` associated with this `TextArea`. For text areas, the `AccessibleContext` takes the form of an `AccessibleAWTTextArea`. A new `AccessibleAWTTextArea` instance is created if necessary.

Specified by:
  `getAccessibleContext` in interface `Accessible`
Overrides:
  `getAccessibleContext` in class `TextComponent`
Returns:
  an `AccessibleAWTTextArea` that serves as the `AccessibleContext` of this `TextArea`
Since:
  1.3